#ifndef __C2P__
#define __C2P__

#pragma once
#include "CUniqueId.h"

typedef struct C2PSELECTIONITEM
{
	CString strSpId;
	CString strSpName;
	CString strNo;
	CString strNo2;
}c2pSelectionItem, *pc2pSelectionItem;

typedef struct C2PSELECTION 
{
	CString strOrder;
	CString strDelphotos;
	CString strDelphotos2;
	CString strbz3; //ѡƬͻҪ
	CString strbz4; //ѡƬƬ޸˵
	CString strbz2; //ƿͻҪ
	CString strbz5; //Ƭ޸˵
	std::vector<c2pSelectionItem> vtItems;
}c2pSelection, *pc2pSelection;


typedef struct SHAREDIR 
{
	bool enable;
	CString strBranchId;
	CString strSharePath;
	int photoType;
}ShareDir, *pShareDir;

class c2p
{
	c2p();
public:
	static c2p* GetInstance()
	{
		static c2p *pInstatnce = nullptr;
		if (!pInstatnce)
		{
			static std::mutex _mutex;
			std::unique_lock<std::mutex> lock{ _mutex };
			if (nullptr == pInstatnce)
			{
				static c2p obj;
				pInstatnce = &obj;
				::CoInitialize(NULL);//ʼCOM  
				pInstatnce->InitAdoPlatinum();
				pInstatnce->InitAdoClassic();
				// ȫuid,64λ,תַ17λ;
				pInstatnce->m_uniqueid.setWorkerId(10);
				pInstatnce->m_uniqueid.setDatacenterId(20);
				// Ҫݿ޸;
				pInstatnce->MustAlterPlatinum();
				// ȡϵ
				pInstatnce->c2pGetClassicPackageType();
			}
		}

		return pInstatnce;
	}

	~c2p();

private:
	_ConnectionPtr m_pPlatinumConnection;
	_ConnectionPtr m_pClassicConnection;
	_RecordsetPtr m_pRecordset;
	CUniqueId m_uniqueid;
	DWORD m_dwIndex;
	CString m_strMsg;
	// ܹ;
	CString m_strClassicDomain;
	// Ŀ¼;
	std::vector<ShareDir> m_vtShareDir;
	// תͯ
	std::vector<std::wstring> m_listPackageType;
	std::vector<std::wstring> m_listResult;
public:
	bool InitAdoClassic();
	bool InitAdoPlatinum();
	const std::vector<std::wstring> &getpackagetype()const {
		return m_listPackageType; 
	};
	void setIntersection(std::vector<std::wstring> &list) {
		// 
		std::sort(m_listPackageType.begin(), m_listPackageType.end());
		std::sort(list.begin(),list.end());

		m_listResult.clear();
		m_listResult.resize(m_listPackageType.size());

		// 
		std::vector<std::wstring>::iterator it = std::set_intersection(list.begin(), list.end(), m_listPackageType.begin(), m_listPackageType.end(), m_listResult.begin());
		m_listResult.resize(it - m_listResult.begin());

		m_listResult.push_back(_T("ɳϵ"));
	}

	void setResult(std::vector<std::wstring> &list) {
		m_listResult.clear();
		m_listResult.resize(list.size());
		std::copy(list.begin(), list.end(), m_listResult.begin());
		m_listResult.push_back(_T("ɳϵ"));
	}
private:
	// ޸ĵĲֶ;
	void MustAlterPlatinum();
	// ȡԱ;
	_variant_t c2pGetEmployeeId(_variant_t employeeName);
	// ʹc2p_orderȡtb_ErpCustomerGroup.GP_CustomerGroupID
	_variant_t c2pGetGroupId(_variant_t &c2p_order);
	// ָ绰Ƿ;
	_variant_t c2pGetCustomerId(_variant_t &varTelphone);
	// ȡָƷƷID;
	_variant_t c2pGetProductId(_variant_t &varGoodsName);
	// ȡƷΨһid;
	_variant_t c2pGetOrderProductUId(_variant_t &varGoodsName, _variant_t &varViceNumber);
	// ȡ֧ʽCodeֵ;
	_variant_t c2pGetPaymentMethodClass(_variant_t &varPaymentName);
	// ͨӵȡ׶;
	_variant_t c2pGetScenicSpotByViceNumber(_variant_t &varViceNumber);
	// ȡtb_ErpOrder.c2p_status;
	_variant_t c2pGetOrderStatus(_variant_t &c2p_order);
	// ȡ涩;
	_variant_t c2pGetOrderNumber(_variant_t &varClassicOrder);
	// Ƿ;
	bool c2pOrderNumberExists(_variant_t &varPlatinumOrder);
	// ѯǷڼ¼;
	_RecordsetPtr c2pQueryExspcits(CString strSql, _ConnectionPtr pConnection);
private:
	// ǩ(ӵ);
	void c2pOrderSingles(_variant_t &varOrder, _variant_t &varEmployeeId, _variant_t &varEmployeeId2, _RecordsetPtr pcRecordSet);
	// ;//Ҫӵ;
	void c2pOrderDigital(_variant_t &varOrder, _RecordsetPtr pcRecordSet);
	// ״̬;//Ҫӵ;
	void c2pOrderDigitalStatus(_variant_t &varOrder, _RecordsetPtr pcRecordSet);
	// ;//Ҫӵ;
	void c2pOrderScenicSpot(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// ˿;
	void c2pOrderCustomerGroup(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// ˿ͱ;
	void c2pCustomers(_variant_t &varClassicOrder, _RecordsetPtr pcRecordSet);
	// Ʒ;//Ҫӵ;
	void c2pOrderGoods(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// տ;
	void c2pRecordOfOrderReceipts(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// Ʒ;
	void c2pOrderReceiptsItem(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// תѡƬ;
	void c2pOrderSelection(c2pSelection &c2pslt);
	// Ƿָתɶͯϵ
	bool isChildOrderType(_variant_t varType);
public:
	// ȡָĿ¼;
	void c2pOrderImg(CString strOrder);
private:
	// ͯɳϵӵ;
	void c2pOrderSubClass(_variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr pcRecordSet);
	// ӵscenicspot;
	void c2pSubOrderScenicSpot(_variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
	// ӵdigital; 
	void c2pSubOrderDigital(const int &nSubId,_variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
	// ӵdigitalstatus; 
	void c2pSubOrderDigitalStatus(const int &nSubId, _variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
	// ӵgoods; 
	void c2pSubOrderGoods(_variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
	// ӵտ; 
	void c2pSubOrderReceiptsRecord(_variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
	// ӵ; 
	void c2pSubOrderReceiptsItem(_variant_t &varSubId, _variant_t &varClassicOrder, _variant_t &varPlatinumOrder, _RecordsetPtr rsdindanjd, _RecordsetPtr rsdindan);
public:
	// ȡĿ¼Ϣ;
	void c2pGetMultipleShareDir();
	// Ƿ;
	bool IsClassicDomainEmpty() { return m_strClassicDomain.IsEmpty(); };
	// ȡ;
	void c2pGetClassicDomain();
	// Ϣ+;
	void c2pBranchInfo();
	// Ϣ;
	void c2pDepartment();
	// ԱϢ;
	void c2pEmployee();
	// Ӧ;
	void c2pSupplier();
	// Ʒ;
	void c2pGoodsType();
	// ƷϢ;
	void c2pGoodsInfo();
	// ϵ;
	void c2pPackageType();
	// ϵϢ;
	void c2pPackageInfo();
	// ϵƷ;
	void c2pPackageGoods();
	// ϵ;
	void c2pPackageGoods2();
	// Ϣ;
	void c2pScenicSpot();
	// ˿͹ϵ;//ֻ"ҳ",""
	void c2pCustomerRelationShip();
	// ˿Դ;
	void c2pCustomerSource();
	// տʽ;
	void c2pPaymentMethod();
	// ;
	void c2pTwopinType();
	// ͻ;
	void c2pClientRegion();
	// ;//,̻;
	void c2pOrderType();
	// ͻ+ǩ(ӵ)+Ʒ++տ;
	void c2pCustomerOrder(CString strOrder = _T(""));
	// Ա;//++绰;
	void c2pMemberShip();
	// ȡϵƣ
	void c2pGetClassicPackageType();
public:
	// ͻ;
	void c2pCustomerType();
	// ҵ;
	void c2pBusinessIntention();
	// ҽԺ;
	void c2pHostpital();
	// ҵ;
	void c2pBusinessTypes();
	// ιʽ;
	void c2pFeedingMode();
	// ҽԺϵͳ;
	void c2pHospitalCustomer();
public:
	// ѡƬ¼;
	void c2pOrderSelection(bool bImg, CString strOrder = _T(""));
	// ѡƬ¼ת;
	bool c2pResetImgConvert();
	// ýӵˣ
	void c2pResetOrderPerson();
	// ԤԼ
	void c2pResetOrderScenicSpot();
	// ԤԼ+
	void c2pResetOrderScenicSpot2();
	// ֻתƬ
	void c2pOnlyConvertImg(CString strOrders = _T(""));
	// ޸ͯʴ⣻
	void c2pRepairCustomer(CString strOrder = _T(""));
	// ɾǳɳϵת
	void c2pResetNotChildOrder(CString strOrder = _T(""));
};

#endif